extends Node

@onready var actor = get_parent().get_parent()

@export var wavedash_jump_stats: JumpStats

# Set by owner
var direction: Vector2

# From 0 to 1
var progression: float

## The speed (y) at the time (x) during dash
@export
var input_to_vel_x: Curve
## Same but when dashing upwards
@export
var input_to_vel_y_up: Curve
## Same but when dashing downwards
@export
var input_to_vel_y_down: Curve

func enter(_args):
	pass

func update(_delta):
	var output_vel := Vector2.ZERO
	output_vel.x = input_to_vel_x.sample(progression) * direction.x
	if direction.y < 0:
		output_vel.y = input_to_vel_y_up.sample(progression) * direction.y
	else:
		output_vel.y = input_to_vel_y_down.sample(progression) * direction.y
	actor.velocity = output_vel
	actor.move_and_slide()

func wavedash_jump():
	actor.velocity.y = - wavedash_jump_stats.initial_velocity
	return wavedash_jump_stats
