extends Area2D

signal hit(data)

@onready var shape := $CollisionShape2D

# Lingering or not?
@export var instant := false

# During one hit, the same hurtbox can only be hit once
var hits := {}

func _ready():
	area_entered.connect(_on_area_entered)
	area_exited.connect(_on_area_exited)

func _process(_delta):
	if !instant:
		for node in hits:
			node.hit()

# Called by owner
func set_active(active):
	shape.disabled = !active
	if !active:
		hits = {}

func _on_area_entered(area):
	if hits.has(area):
		return
	hits[area] = true
	area.hit()
	hit.emit({})

func _on_area_exited(area):
	hits.erase(area)
